<?php
// +----------------------------------------------------------------------
// | 微服务-配置调用类
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace SwooleXRpc;

class Rpc
{
    private static $instance = null; // 创建静态对象变量,用于存储唯一的对象实例  
    private function __construct(){} // 私有化构造函数，防止外部调用
    private function __clone(){}     // 私有化克隆函数，防止外部克隆对象
    private static $config; // 配置

    /**
     * 实例化对象方法，供外部获得唯一的对象
    */
    public static function run(){
        if (empty(self::$instance)) {
            require_once dirname(__FILE__).'/lifecycle/rpc_error.php';
            self::$config = require dirname(__FILE__).'/config/rpc.php';
            self::$instance = new \SwooleXRpc\Rpc();
        }
        return self::$instance;
    }

    /**
     * 当检测失败时，回调的处理函数
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function ping_error($config, $status) {
        rpc_error($config['class'], $config['function'], $config, $status);
        return false;
    }

    /**
     * 读取配置
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function get($class, $function) {
        $redis_key = self::$config['redis_key'].'_'.md5($class.$function);

        // 读取某个服务
        $index = \SwooleXRpc\RpcRedis::run()->llen($redis_key);
        $list = array();
        for ($i=0; $i<$index; $i++) {
            $json = \SwooleXRpc\RpcRedis::run()->lindex($redis_key, $i);

            if ($json) {
                $list[] = json_decode($json, true);
            }
        }

        return $list;
    }

    /**
     * 更新单条配置
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function set($config) {
        $redis_index = $config['redis_index'];
        unset($config['redis_index']);
        $redis_key = self::$config['redis_key'].'_'.md5($config['class'].$config['function']);
        $res = \SwooleXRpc\RpcRedis::run()->lset($redis_key, $redis_index, json_encode($config, JSON_UNESCAPED_UNICODE));
        return $res;
    }
    
    
}